;************************************** LCD_05.asm *************************************
;
; PARA LA EASYPIC
; Cada vez que presiona el pulsador conectado al pin RA4 incrementa un contador
; visualizado en el centro de la primera lnea de la pantalla.
;
; El pulsador conectado al pin RA4 en la EasyPIC es activo a nivel alto, es decir,
; cuando est pulsado RA4=5V.
;
;
; ZONA DE DATOS **********************************************************************

	__CONFIG   _CP_OFF &  _WDT_OFF & _PWRTE_ON & _HS_OSC
	LIST	   P=16F877A
	INCLUDE  <P16F877A.INC>

	CBLOCK  0x20
	Contador			; El contador a visualizar.
	ENDC

#DEFINE  Pulsador PORTA,4		; Lnea donde se conecta el pulsador.

; ZONA DE CDIGOS ********************************************************************

	ORG	0
Inicio
	call	LCD_Inicializa
	bsf		STATUS,RP0
	bsf		Pulsador		; Lnea del pulsador se configura como entrada. 
	bcf		STATUS,RP0
	clrf	Contador		; Inicializa contador y los visualiza por 1 vez,
	call	Visualiza
Principal
	btfsc	Pulsador		; Lee el pulsador.
	call	IncrementaVisualiza	; Si pulsa salta a incrementar y visualizar el
	goto	Principal		; contador
	
; Subrutina "IncrementaVisualiza" -------------------------------------------------------
;
IncrementaVisualiza
	call	Retardo_20ms		; Espera a que se estabilicen los niveles de tensin.
        call	Retardo_20ms		; Espera a que se estabilicen los niveles de tensin.
	btfss	Pulsador		; Vuelve a leer el pulsador.
	goto	Fin_Incrementa
	incf	Contador,F		; Incrementa el contador y despus lo visualiza.
Visualiza
	movlw	.7			; Se sita en el centro de la lnea 1.
	call	LCD_PosicionLinea1
	movf	Contador,W
	call	BIN_a_BCD		; Se debe visualizar en decimal.
	call	LCD_Byte
EsperaDejePulsar
	btfsc	Pulsador
	goto	EsperaDejePulsar
Fin_Incrementa
	return

	INCLUDE  <RETARDOS.INC>
	INCLUDE  <BIN_BCD.INC>
	INCLUDE  <LCD_EASY.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
